#include "bc_regs.h"

void bc_regs::out_source1() {

  sc_uint<16 > localData;

  switch(ir.read().range(7,4)){
    case 0:
      localData=r_i_0;
      break;
    case 1:
      localData=r_i_1;
      break;
    case 2:
      localData=r_i_2;
      break;
    case 3:
      localData=r_i_3;
      break;
    case 4:
      localData=r_i_4;
      break;
    case 5:
      localData=r_i_5;
      break;
    case 6:
      localData=r_i_6;
      break;
    case 7:
      localData=r_i_7;
      break;
    case 8:
      localData=r_i_8;
      break;
    case 9:
      localData=r_i_9;
      break;
    case 10:
      localData=r_i_10;
      break;
    case 11:
      localData=r_i_11;
      break;
    case 12:
      localData=r_i_12;
      break;
    case 13:
      localData=r_i_13;
      break;
    case 14:
      localData=r_i_14;
      break;
    case 15:
      localData=r_i_15;
      break;
  }

  source1 = localData;
}

void bc_regs::out_source2() {

  sc_uint<16 > localData;

  if ( ms2 ){
    switch(ir.read().range(11,8)){
      case 0:
        localData=r_i_0;
        break;
      case 1:
        localData=r_i_1;
        break;
      case 2:
        localData=r_i_2;
        break;
      case 3:
        localData=r_i_3;
        break;
      case 4:
        localData=r_i_4;
        break;
      case 5:
        localData=r_i_5;
        break;
      case 6:
        localData=r_i_6;
        break;
      case 7:
        localData=r_i_7;
        break;
      case 8:
        localData=r_i_8;
        break;
      case 9:
        localData=r_i_9;
        break;
      case 10:
        localData=r_i_10;
        break;
      case 11:
        localData=r_i_11;
        break;
      case 12:
        localData=r_i_12;
        break;
      case 13:
        localData=r_i_13;
        break;
      case 14:
        localData=r_i_14;
        break;
      case 15:
        localData=r_i_15;
        break;
    }
    source2 = localData;
  }
  else{
    switch(ir.read().range(3,0)){
      case 0:
        localData=r_i_0;
        break;
      case 1:
        localData=r_i_1;
        break;
      case 2:
        localData=r_i_2;
        break;
      case 3:
        localData=r_i_3;
        break;
      case 4:
        localData=r_i_4;
        break;
      case 5:
        localData=r_i_5;
        break;
      case 6:
        localData=r_i_6;
        break;
      case 7:
        localData=r_i_7;
        break;
      case 8:
        localData=r_i_8;
        break;
      case 9:
        localData=r_i_9;
        break;
      case 10:
        localData=r_i_10;
        break;
      case 11:
        localData=r_i_11;
        break;
      case 12:
        localData=r_i_12;
        break;
      case 13:
        localData=r_i_13;
        break;
      case 14:
        localData=r_i_14;
        break;
      case 15:
        localData=r_i_15;
        break;
    }
    source2 = localData;
  }

}

// Habilitao dos registradores
void bc_regs::decodificador() {


  wen_i_0  = false;
  wen_i_1  = false;
  wen_i_2  = false;
  wen_i_3  = false;
  wen_i_4  = false;
  wen_i_5  = false;
  wen_i_6  = false;
  wen_i_7  = false;
  wen_i_8  = false;
  wen_i_9  = false;
  wen_i_10 = false;
  wen_i_11 = false;
  wen_i_12 = false;
  wen_i_13 = false;
  wen_i_14 = false;
  wen_i_15 = false;

  if ( wreg )

    switch(ir.read().range(11,8)){
      case 0:
        wen_i_0= true;
        break;
      case 1:
        wen_i_1= true;
        break;
      case 2:
        wen_i_2 = true;
        break;
      case 3:
        wen_i_3 = true;
        break;
      case 4:
        wen_i_4 = true;
        break;
      case 5:
        wen_i_5 = true;
        break;
      case 6:
        wen_i_6= true;
        break;
      case 7:
        wen_i_7 = true;
        break;
      case 8:
        wen_i_8 = true;
        break;
      case 9:
        wen_i_9 = true;
        break;
      case 10:
        wen_i_10 = true;
        break;
      case 11:
        wen_i_11 = true;
        break;
      case 12:
        wen_i_12 = true;
        break;
      case 13:
        wen_i_13 = true;
        break;
      case 14:
        wen_i_14 = true;
        break;
      case 15:
        wen_i_15 = true;
        break;
    }

}

