// Registrador de uso geral - SENSIVEL A BORDA DE DESCIDA
#ifndef _reg16_h
#define _reg16_h

#include <systemc.h>

SC_MODULE(reg16) {

  sc_in< bool > clock, reset, ce;
  sc_in< sc_uint<16> > D;

  sc_out< sc_uint<16> > Q;

  void reg();

  SC_CTOR(reg16) {
    SC_METHOD(reg);
    sensitive << reset.pos();
    sensitive << clock.neg();
  }
};

#endif
